Attribute VB_Name = "CommonSetup"
Option Explicit
' ACHTUNG: InitModul zur Initialisierung aufrufen
' #######################
' Constructor: B.Ottmann
' #######################

' Wird aus Initialisierungsdatei gelesen und gibt an ob Anwendung im internen - Debug
Public data_debug As Integer

Public data_length As Integer
Public data_length1 As Integer

Public data_string As String
Public data_string_hex As String

' Angesprochenes Geraet
Public DeviceString As String

' Dies ist das Zentrale Setup-Modul.
' Es definiert Konstante und Typen.
' Es stellt allgemeine Routinen bereit.

' max. Lnge Datensatz ohne Verwaltungsdaten
Public Const MAX_DATENSATZ As Byte = 244
' max. Felder in einem Datensatz
Public Const MAX_FELD  As Byte = 25
' max. Unterpunkte im Baum (Konfig, Datensatzb. und Listenb.)
Public Const MAX_UNTERPUNKTE As Byte = 100
' max. Anzahl Datenstze
Public Const MAX_DATENSAETZE As Long = 70577
' auch max. Listen
Public Const MAX_DATENSATZ_BESCHREIBUNG  As Byte = 20
' max. Zeichen fr Datensatz/Feld-Name incl. abschliesende Null
Public Const MAX_DS_NAME  As Byte = 17

' Anzahl der Datensatzbeschreibungen und Felder
Public DSBCount As Integer
Public DSBFieldCount As Integer

' Anzahl der Listenbeschreibungen und Felder
Public LSBCount As Integer
Public LSBFieldCount As Integer

' Type fuer ein Datensatzfeld
Public Type TDatensatzFeld
    Typ As Long       ' Aufzhlung Typ des Feldes
    Cnt As Long       ' Lnge des Feldes inc. anbschlieende '\0' bei Strings
    Bezeichnung As String '* MAX_DS_NAME    ' Name des Feldes
    Value As Variant          ' Wert
End Type

' Type fuer eine Datensatzbeschreibung
Public Type TDatensatzBeschreibung
    Key As Long       ' z.B Nummer der Datensatzbeschreibung
    Felder As Long    ' Anzahl Felder im Datensatz
    Bezeichnung As String '* MAX_DS_NAME  ' Name der Datensatzbeschreibung
    Status As Long          ' Return von GetDatensatz
    Feld(MAX_FELD) As TDatensatzFeld ' Array (Typ "TDatensatzFeld")
End Type

' Leere Datensatzbeschreibung als Fehlerrueckgabe
Public DSBEmpty As TDatensatzBeschreibung
' Aktuelle DSB wird hier gehalten
Public DSBCurrent As TDatensatzBeschreibung

' * Abschnitt fuer ListBox
' Konstanten Flags fuer Kennzeichnung der Listeneintraege
Public Const KEY_INFO As Long = &H1000
Public Const KEY_HEADER As Long = &H2000
Public Const KEY_VALUE As Long = &H4000

' Feldtypen
'Public Const TF_ULONG As Byte = 1      ' 4 Byte
Public Const TF_DT As Byte = 2         ' Date und Time 7 Byte -> 4 Byte Date und 3 Byte Time
Public Const TF_NUM  As Byte = 3       ' wie Typ TF_A_NUM, es sind jedoch nur Ziffern erlaubt
Public Const TF_A_NUM  As Byte = 4     ' Alpha-Numerisch ASCII Lngenangabe notwendig
'Public Const TF_DATE   As Byte = 5     ' 4 Byte Y100,Y,M,D
'Public Const TF_TIME   As Byte = 6     ' 3 Byte H,Mi,S
' Lnge der Feldtypen
'Public Const TF_ULONG_LEN   As Byte = 4    ' 4 Byte
Public Const TF_DATE_LEN   As Byte = 4     ' 4 Byte Y100,Y,M,D
Public Const TF_TIME_LEN   As Byte = 3     ' 3 Byte H,Mi,S
Public Const TF_DT_LEN     As Byte = 7     ' Date und Time 7 Byte -> 4 Byte Date und 3 Byte Time

' Allgemeine Def. fr Konfiguration
Public Const MAX_MENUE_TXT  As Byte = 17   ' Lnge Texte im Menue incl. NULL
Public Const MAX_S_FELD_TXT  As Byte = 17  ' Lnge fr Text S-Felder incl. NULL
Public Const MAX_DATEN_LEN   As Byte = 21  ' max. Lnge fr ein Datensatzfeld

Public Sub InitModul()
    ' Initialisieren der leeren DSB
    DSBEmpty.Key = -1
    DSBEmpty.Bezeichnung = "Empty"
    DSBEmpty.Felder = 0
    DSBEmpty.Status = 0
    
    DSBCount = 0
    DSBFieldCount = 0
    LSBCount = 0
    LSBFieldCount = 0
    
End Sub

' Fuer die Fortschrittsanzeige
Public Function CallBack() As Long
    CallBack = frmHaupt.CBFunction
End Function

' Zum pruefen der gelesenen Datensatzlaenge mit der
' gewaehlten Setup-Datensatzbeschreibung in GetData
Private Function GetDSBLen(DSB As TDatensatzBeschreibung) As Integer
    Dim Laenge As Integer
    Dim ColumnNr As Integer
    For ColumnNr = 0 To DSB.Felder - 1
        Laenge = Laenge + DSB.Feld(ColumnNr).Cnt
    Next ColumnNr
    GetDSBLen = Laenge
End Function

' Aufruf von DFCComGetDatensatz und ablegen der Werte in die
' entsprechende Datensatzbeschreibung.
' Diese ist Returnwert und abhaengig vom verwendeten Setup

Public Function GetData(ComNr As Long) As TDatensatzBeschreibung
    Dim Status As Long ' Datensatzstatus
    Dim Error As Long  ' Fehlercode aufnehmen
    Dim Laenge As Long ' Datensatzlaenge aufnehmen
    Dim Buf As String  ' Buffer fuer Datensatz
    ' Initialisieren auf Maximallaenge eines Datensatztes
    Buf = String(CommonSetup.MAX_DATENSATZ, Chr(0))
    ' Datensatz aus DLL in Application holen
    Status = DFCComGetDatensatz(ComNr, Buf, Laenge, Error)
    ' -1 -> Fehler
    '  0 -> Keine Daten vorhanden
    '  1 -> Weitere Datensaetze vorhanden
    '  2 -> Letzter Datensatz
    '  3 -> Online Datensatz
    '  4 -> Offline Datensatz
    CommonSetup.DSBEmpty.Status = Status
    ' Pruefen ob Fehler eingetreten
    If Status = -1 Then
    
        DFCommon.ErrorMsg Error
        GetData = CommonSetup.DSBEmpty
        Exit Function
    End If

    If Status = 0 Then
    
        GetData = CommonSetup.DSBEmpty
        Exit Function
    End If
    
    data_length = 0
    data_string = "GetData( " + CStr(Laenge) + " ), "
    data_string_hex = "GetData( " + CStr(Hex(Laenge)) + " ), "
    
    ' Byte 0 enthaelt zugehoerige Datensatzbeschreibung
    Dim DSBNr As Long
    DSBNr = Asc(Mid(Buf, 1, 1))
    ' ermittlung der Datensatzbeschreibung zur Nr
    GetData = ReadDatensatzBeschreibung(ComNr, DSBNr)
    If GetData.Felder = 0 Then ' Empty auffangen
        MsgBox "Gelesene Datensatzbeschreibung nicht definiert.", vbExclamation
        Exit Function
    End If
    
    ' Felder mit Werte fuellen
    Dim pos As Byte
    pos = 1
    Dim ColumnNr As Byte
    For ColumnNr = 0 To GetData.Felder - 1
        Select Case GetData.Feld(ColumnNr).Typ
        Case TF_DT
            ' wegen Uebersichtlichkeit ueber Bytearray umsetzten
            Dim dt(6) As Byte ' DateTime
            Dim i As Byte
            For i = 0 To 6
                dt(i) = Asc(Mid(Buf, pos + i + 1, 1))
            Next i
            ' Format dd.mm.yyyy hh:mm:ss
            GetData.Feld(ColumnNr).Value = _
            Format(dt(3), "00") & "." & _
            Format(dt(2), "00") & "." & _
            Format(dt(0), "00") & _
            Format(dt(1), "00") & " " & _
            Format(dt(4), "00") & ":" & _
            Format(dt(5), "00") & ":" & _
            Format(dt(6), "00")
        Case TF_A_NUM, TF_NUM
            ' Bis Chr(0) als Wert aufnehmen.
            Dim laengeIn As Long
            laengeIn = InStr(1, Mid(Buf, pos + 1, GetData.Feld(ColumnNr).Cnt), Chr(0)) - 1
            If laengeIn <= 0 Then
                GetData.Feld(ColumnNr).Value = frmHaupt.lblEmptyFail.Caption
            Else
                GetData.Feld(ColumnNr).Value = Left(Mid(Buf, pos + 1, GetData.Feld(ColumnNr).Cnt), laengeIn)
            End If
        End Select
        ' Position im Buffer auf naechten Feldanfang setzten
        pos = pos + GetData.Feld(ColumnNr).Cnt
        
        data_string = data_string + Chr(13)
        data_string = data_string + "Field( " + CStr(ColumnNr) + ", " + CStr(Hex(GetData.Feld(ColumnNr).Cnt)) + " ), "
        
        data_string_hex = data_string_hex + Chr(13)
        data_string_hex = data_string_hex + "Field( " + CStr(ColumnNr) + ", " + CStr(Hex(GetData.Feld(ColumnNr).Cnt)) + " ), "
        
        data_length = data_length + GetData.Feld(ColumnNr).Cnt
    Next ColumnNr
    
    data_string = data_string + Chr(13)
    data_string = data_string + "Summe: ( " + CStr(data_length) + " )"
    
    data_string_hex = data_string_hex + Chr(13)
    data_string_hex = data_string_hex + "Summe: ( " + CStr(Hex(data_length)) + " )"
    
    ' Datensatzstatus 1 oder 2 an DSB uebergeben.
    GetData.Status = Status
End Function



' Je nach gewaehlten Setup werden die Listen konstruiert.
' Die Modulroutinen ermoeglichen verschiedene Erstellungsmoeglichkeiten
Public Function MakeListen(ComNum As Long, LSBNum As Long) As Boolean
    
    frmHaupt.dlgLaden.Filter = "Listendatei (*.txt)|*.txt"
    frmHaupt.dlgLaden.Flags = Flags_TransmitConfig
    
    frmHaupt.dlgLaden.CancelError = True
    
    'Bei "Abbrechen" wird eine Exception ausgelst
    On Error GoTo error_handle
    frmHaupt.dlgLaden.ShowOpen
    
    If frmHaupt.dlgLaden.FileName <> "" Then
        
        If MakeFileListe(ComNum, LSBNum, frmHaupt.dlgLaden.FileName) = 0 Then
            
            MakeListen = False
            Exit Function
        End If
        
    End If
    
    MakeListen = True
    
    Exit Function

error_handle:
    Err.Clear
    MakeListen = False
    
End Function

' Laden einer Liste aus Datei und in den DLL internen Buffer uebertragen
' Ausfuehrung mit String Buffer
' Es werden (nur Ziffern) und (Zeichenketten ASCII) unterstuetzt.
' LSBNr ist die Listenbeschreibungsnummer im Setup. Erste hat Nummer 0
Public Function MakeFileListe(ComNr As Long, LSBNr As Long, FileName As String) As Boolean
    ' Fehler verarbeiten
    On Error GoTo error_handle
       
    ' Listenbeschreibung ermitteln
    Dim LSB As TDatensatzBeschreibung
    LSB = ReadListenBeschreibung(ComNr, LSBNr)
    If LSB.Felder = 0 Then ' Empty auffangen
        
        Debug.Print "Keine Listenbeschreibung fr " & LSBNr
        Exit Function
    End If
    
    ' Variable
    Dim LineCount As Long
    LineCount = 0
    Dim ColumnNr As Long
    Dim ListSize As Long
    ' Buffer
    Dim Buf As String, LineText As String, Feld
    
    ' Datei oeffnen
    Dim FileNum As Integer
    FileNum = FreeFile
    Open FileName For Input As #FileNum
    Do
        LineCount = LineCount + 1
        ' Zeile aus Datei lesen
        Line Input #FileNum, LineText
        ' In Feld zerlegen. Trennzeichen Tab
        Feld = Split(LineText, vbTab)
        ColumnNr = 0
        
        ' Spalte pruefen und mit Chr(0) auffuellen
        Do Until ColumnNr = LSB.Felder
            ' Feldinhalt muss in Laenge und Type passen
            If LSB.Feld(ColumnNr).Cnt > Len(Feld(ColumnNr)) And _
            (LSB.Feld(ColumnNr).Typ = TF_A_NUM Or _
            (LSB.Feld(ColumnNr).Typ = TF_NUM And IsNumeric(Feld(ColumnNr)))) Then
                ' Auf Feldlaenge gebrachter String anhaengen.
                'Buf = Buf & Feld(ColumnNr) & String(LSB.Feld(ColumnNr).Cnt - Len(Feld(ColumnNr)), Chr(0))
                Buf = Buf & Trim(Feld(ColumnNr)) & String(LSB.Feld(ColumnNr).Cnt - Len(Trim(Feld(ColumnNr))), Chr(0))
            Else ' Format Fehler
                Err.Description = "Format in Spalte " & ColumnNr + 1 & " Zeile " & LineCount & " verursacht Unstimmigkeit."
                GoTo error_handle
            End If
            ' ListSize anpassen
            ListSize = ListSize + LSB.Feld(ColumnNr).Cnt
            ' naechste Zelle
            ColumnNr = ColumnNr + 1
        Loop
    Loop Until EOF(FileNum)
    
    ' Datei schliessen
    Close #FileNum
    
    ' Uebergeben in DLL internen Buffer
    If DFCMakeListe(ComNr, LSBNr, LineCount, ListSize, Buf, 0) = 0 Then
        
        MakeFileListe = False
        Exit Function
    End If
    
    ' Erfolgreich
    MakeFileListe = True
    Exit Function
    
error_handle:
    If Not FileNum = 0 Then
        Close #FileNum
    End If
    MakeFileListe = False
    MsgBox Err.Description, vbCritical, "Error"
    Err.Clear
End Function


Public Function ReadDatensatzBeschreibung(ByVal ComNr As Long, ByVal Key As Long) As TDatensatzBeschreibung
    
    Dim Error As Long
    Dim Tabellenanzahl As Long
    Dim Meldung As String
    Dim DSBName As String * 17
    Dim DSBAnzahlFelder As Long
    Dim Feldname As String * 17
    Dim Feldtyp As Long
    Dim Feldlaenge As Long
    
    Dim lfd_feld As Long
    Dim dsf As TDatensatzFeld
    
    
    ReadDatensatzBeschreibung = CommonSetup.DSBEmpty
    ReadDatensatzBeschreibung.Key = Key
    
    
    
    If DFCDatBDatensatz(ComNr, Key, DSBName, DSBAnzahlFelder) = 0 Then
        'Satzbeschreibung nicht vorhanden
        ReadDatensatzBeschreibung.Status = -1
        
    Else
        ReadDatensatzBeschreibung.Felder = DSBAnzahlFelder
        ReadDatensatzBeschreibung.Bezeichnung = Left(DSBName, InStr(1, DSBName, Chr(0)) - 1)
        
        For lfd_feld = 0 To DSBAnzahlFelder - 1
        
        
           If DFCDatBFeld(ComNr, Key, lfd_feld, Feldname, Feldtyp, Feldlaenge) = 0 Then
             'Feld nicht vorhanden
             dsf.Bezeichnung = ""
             dsf.Typ = -1
             dsf.Cnt = 0
             
           Else
             dsf.Bezeichnung = Left(Feldname, InStr(1, Feldname, Chr(0)) - 1)
             dsf.Typ = Feldtyp
             dsf.Cnt = Feldlaenge
           End If
           
           ReadDatensatzBeschreibung.Feld(lfd_feld) = dsf
        
        
        Next lfd_feld

    End If
    
End Function

Public Function ReadListenBeschreibung(ByVal ComNr As Long, ByVal Key As Long) As TDatensatzBeschreibung
    
    Dim Error As Long
    Dim Tabellenanzahl As Long
    Dim Meldung As String
    Dim DSBName As String * 17
    Dim DSBAnzahlFelder As Long
    Dim DSBVar As Long
    Dim Feldname As String * 17
    Dim Feldtyp As Long
    Dim Feldlaenge As Long
    
    Dim lfd_feld As Long
    Dim dsf As TDatensatzFeld
    
    
    ReadListenBeschreibung = CommonSetup.DSBEmpty
    ReadListenBeschreibung.Key = Key
    
    
    
    If DFCListBDatensatz(ComNr, Key, DSBName, DSBAnzahlFelder, DSBVar) = 0 Then
        'Satzbeschreibung nicht vorhanden
        ReadListenBeschreibung.Status = -1
        
    Else
        ReadListenBeschreibung.Felder = DSBAnzahlFelder
        ReadListenBeschreibung.Bezeichnung = Left(DSBName, InStr(1, DSBName, Chr(0)) - 1)
        
        For lfd_feld = 0 To DSBAnzahlFelder - 1
        
        
           If DFCListBFeld(ComNr, Key, lfd_feld, Feldname, Feldtyp, Feldlaenge) = 0 Then
             'Feld nicht vorhanden
             dsf.Bezeichnung = ""
             dsf.Typ = -1
             dsf.Cnt = 0
             
           Else
             dsf.Bezeichnung = Left(Feldname, InStr(1, Feldname, Chr(0)) - 1)
             dsf.Typ = Feldtyp
             dsf.Cnt = Feldlaenge
           End If
           
           ReadListenBeschreibung.Feld(lfd_feld) = dsf
        
        
        Next lfd_feld

    End If
    
End Function

Public Sub RTrimNull(str As String)
    Dim i
    For i = Len(str) To 1 Step -1
        If Mid(str, i, 1) = " " Then
            Mid(str, i, 1) = Chr(0)
        Else
            i = 1
        End If
    Next
End Sub

